## stdgpu 1.3.0+git20220507.32e0517

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18...3.26)
message(STATUS "Configuring with CMake ${CMAKE_VERSION}")


project(stdgpu VERSION 1.3.0
               DESCRIPTION "Efficient STL-like Data Structures on the GPU"
               LANGUAGES CXX)


if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(STDGPU_SETUP_COMPILER_FLAGS_DEFAULT ON)
else()
    set(STDGPU_SETUP_COMPILER_FLAGS_DEFAULT OFF)
endif()

option(STDGPU_BUILD_SHARED_LIBS "Builds the project as a shared library, if set to ON, or as a static library, if set to OFF, default: BUILD_SHARED_LIBS" ${BUILD_SHARED_LIBS})
option(STDGPU_SETUP_COMPILER_FLAGS "Constructs the compiler flags, default: ON if standalone, OFF if included via add_subdirectory" ${STDGPU_SETUP_COMPILER_FLAGS_DEFAULT})
option(STDGPU_COMPILE_WARNING_AS_ERROR "Treats compiler warnings as errors, default: OFF" OFF)
option(STDGPU_BUILD_EXAMPLES "Build the examples, default: ON" ON)
option(STDGPU_BUILD_BENCHMARKS "Build the benchmarks, default: ON" ON)
option(STDGPU_BUILD_TESTS "Build the unit tests, default: ON" ON)
option(STDGPU_BUILD_TEST_COVERAGE "Build a test coverage report, default: OFF" OFF)
option(STDGPU_ANALYZE_WITH_CLANG_TIDY "Analyzes the code with clang-tidy, default: OFF" OFF)
option(STDGPU_ANALYZE_WITH_CPPCHECK "Analyzes the code with cppcheck, default: OFF" OFF)


set(STDGPU_BACKEND_CUDA "STDGPU_BACKEND_CUDA")
set(STDGPU_BACKEND_OPENMP "STDGPU_BACKEND_OPENMP")
set(STDGPU_BACKEND_HIP "STDGPU_BACKEND_HIP")
list(APPEND STDGPU_BACKEND_OPTIONS ${STDGPU_BACKEND_CUDA} ${STDGPU_BACKEND_OPENMP} ${STDGPU_BACKEND_HIP})

# STDGPU_BACKEND
set(STDGPU_BACKEND ${STDGPU_BACKEND_CUDA} CACHE STRING "Device system backend, default: STDGPU_BACKEND_CUDA")
if(NOT STDGPU_BACKEND IN_LIST STDGPU_BACKEND_OPTIONS)
    message(FATAL_ERROR "STDGPU_BACKEND is set to \"${STDGPU_BACKEND}\", but must be one of \"${STDGPU_BACKEND_OPTIONS}\"")
endif()

# STDGPU_BACKEND_DIRECTORY
set(STDGPU_BACKEND_DIRECTORY ${STDGPU_BACKEND})
string(REGEX REPLACE "^STDGPU_BACKEND_" "" STDGPU_BACKEND_DIRECTORY ${STDGPU_BACKEND_DIRECTORY})
string(TOLOWER ${STDGPU_BACKEND_DIRECTORY} STDGPU_BACKEND_DIRECTORY)

# STDGPU_BACKEND_NAMESPACE
set(STDGPU_BACKEND_NAMESPACE ${STDGPU_BACKEND_DIRECTORY})

# STDGPU_BACKEND_MACRO_NAMESPACE
set(STDGPU_BACKEND_MACRO_NAMESPACE ${STDGPU_BACKEND_NAMESPACE})
string(TOUPPER ${STDGPU_BACKEND_MACRO_NAMESPACE} STDGPU_BACKEND_MACRO_NAMESPACE)


# Enable backend-specific languages
if(STDGPU_BACKEND STREQUAL STDGPU_BACKEND_CUDA)
    if(DEFINED CMAKE_CUDA_ARCHITECTURES)
        set(STDGPU_CUDA_ARCHITECTURE_FLAGS_USER ${CMAKE_CUDA_ARCHITECTURES})
    endif()

    enable_language(CUDA)
elseif(STDGPU_BACKEND STREQUAL STDGPU_BACKEND_HIP)
    cmake_minimum_required(VERSION 3.21.3...3.26)

    if(DEFINED CMAKE_HIP_ARCHITECTURES)
        set(STDGPU_HIP_ARCHITECTURE_FLAGS_USER ${CMAKE_HIP_ARCHITECTURES})
    endif()

    enable_language(HIP)
endif()


# Backend-specific modules have higher priority than generic modules
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/${STDGPU_BACKEND_DIRECTORY}")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")


if(STDGPU_SETUP_COMPILER_FLAGS)
    include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/${STDGPU_BACKEND_DIRECTORY}/set_device_flags.cmake")
    stdgpu_set_device_flags(STDGPU_DEVICE_FLAGS)
    stdgpu_set_test_device_flags(STDGPU_TEST_DEVICE_FLAGS)
    message(STATUS "Created device flags : ${STDGPU_DEVICE_FLAGS}")
    message(STATUS "Created test device flags : ${STDGPU_TEST_DEVICE_FLAGS}")

    if(STDGPU_BACKEND STREQUAL STDGPU_BACKEND_CUDA)
        if(STDGPU_CUDA_ARCHITECTURE_FLAGS_USER)
            # CMAKE_CUDA_ARCHITECTURES already set by the user
            message(STATUS "Detected user-provided CCs : ${STDGPU_CUDA_ARCHITECTURE_FLAGS_USER}")
        else()
            stdgpu_cuda_set_architecture_flags(STDGPU_CUDA_ARCHITECTURE_FLAGS)
            if(STDGPU_CUDA_ARCHITECTURE_FLAGS)
                set(CMAKE_CUDA_ARCHITECTURES ${STDGPU_CUDA_ARCHITECTURE_FLAGS})
            else()
                message(WARNING "Falling back to default CCs : ${CMAKE_CUDA_ARCHITECTURES}")
            endif()
        endif()

        # Workaround for bug in libstdc++ (see https://gitlab.kitware.com/cmake/cmake/-/merge_requests/4442#note_737136)
        if(CMAKE_CUDA_COMPILER_ID STREQUAL "Clang")
            message(STATUS "Building with disabled CXX extensions")
            set(CMAKE_CXX_EXTENSIONS OFF)
        endif()
    elseif(STDGPU_BACKEND STREQUAL STDGPU_BACKEND_HIP)
        if(STDGPU_HIP_ARCHITECTURE_FLAGS_USER)
            # CMAKE_HIP_ARCHITECTURES already set by the user
            message(STATUS "Detected user-provided CCs : ${STDGPU_HIP_ARCHITECTURE_FLAGS_USER}")
        else()
            # NOTE : Architectures could be detected via the "gcnArchName" property
            message(WARNING "Falling back to default CCs : ${CMAKE_HIP_ARCHITECTURES}")
        endif()
    endif()

    include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/set_host_flags.cmake")
    stdgpu_set_host_flags(STDGPU_HOST_FLAGS)
    stdgpu_set_test_host_flags(STDGPU_TEST_HOST_FLAGS)
    message(STATUS "Created host flags : ${STDGPU_HOST_FLAGS}")
    message(STATUS "Created test host flags : ${STDGPU_TEST_HOST_FLAGS}")
endif()


if(STDGPU_BUILD_TESTS AND STDGPU_BUILD_TEST_COVERAGE)
    include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/code_coverage.cmake")
    append_coverage_compiler_flags()
    set(COVERAGE_EXCLUDES '*CMake*' '*build/*' '*benchmark/*' '*examples/*' '*external/*' '*test/*' '/usr/*')
endif()


if(STDGPU_ANALYZE_WITH_CLANG_TIDY)
    include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/setup_clang_tidy.cmake")
    stdgpu_setup_clang_tidy(STDGPU_PROPERTY_CLANG_TIDY)
endif()

if(STDGPU_ANALYZE_WITH_CPPCHECK)
    include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/setup_cppcheck.cmake")
    stdgpu_setup_cppcheck(STDGPU_PROPERTY_CPPCHECK)
endif()


option(STDGPU_ALLOW_NEWER_CLANG_FORMAT_VERSIONS "CAUTION: Allows finding newer versions of clang-format which may produce different results (WILL BE REJECTED), default: OFF" OFF)
include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/setup_clang_format.cmake")
stdgpu_setup_clang_format()


# Setup output directory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")


# Setup install paths
include(GNUInstallDirs)
set(STDGPU_LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
set(STDGPU_BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})
set(STDGPU_INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(STDGPU_CMAKE_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/stdgpu")
set(STDGPU_DOC_INSTALL_DIR "${CMAKE_INSTALL_DOCDIR}/stdgpu")


# External dependencies directory
set(STDGPU_EXTERNAL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/external")


add_subdirectory(src)

add_subdirectory(doc)


# Install exported targets and cmake files
install(EXPORT stdgpu-targets
        NAMESPACE stdgpu::
        DESTINATION "${STDGPU_CMAKE_INSTALL_DIR}"
        COMPONENT stdgpu)

include(CMakePackageConfigHelpers)
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/stdgpu-config.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/stdgpu-config.cmake"
                              INSTALL_DESTINATION ${STDGPU_CMAKE_INSTALL_DIR}
                              PATH_VARS STDGPU_INCLUDE_INSTALL_DIR)

write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/stdgpu-config-version.cmake"
                                 VERSION ${stdgpu_VERSION}
                                 COMPATIBILITY SameMajorVersion)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/stdgpu-config.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/stdgpu-config-version.cmake"
        DESTINATION "${STDGPU_CMAKE_INSTALL_DIR}"
        COMPONENT stdgpu)


include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/add_uninstall_target.cmake")


if(STDGPU_BUILD_EXAMPLES)
    enable_testing()
    add_subdirectory(examples)
endif()

if(STDGPU_BUILD_BENCHMARKS)
    add_subdirectory(benchmark)
endif()

if(STDGPU_BUILD_TESTS)
    enable_testing()

    add_subdirectory(test)

    if(STDGPU_BUILD_TEST_COVERAGE)
        setup_target_for_coverage(NAME stdgpu_coverage
                                  EXECUTABLE ${CMAKE_COMMAND} -E chdir .. sh scripts/run_tests.sh ${CMAKE_BUILD_TYPE}
                                  DEPENDENCIES teststdgpu)
    endif()

endif()

include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/config_summary.cmake")
stdgpu_print_configuration_summary()

=== doc/CMakeLists.txt ===

find_package(Doxygen 1.9.6 EXACT QUIET)

if(NOT Doxygen_FOUND)
    include(ExternalProject)

    ExternalProject_Add(
        doxygen
        PREFIX doxygen
        URL https://github.com/doxygen/doxygen/archive/refs/tags/Release_1_9_6.zip
        URL_HASH SHA256=28ab2c5d2ba1d3ed56c538125f1cad7ca8a09992e8b3892e9533736268ff6426
        DOWNLOAD_DIR "${STDGPU_EXTERNAL_DIR}/doxygen"
        UPDATE_COMMAND ""
        INSTALL_COMMAND ""
        CMAKE_ARGS
            -DCMAKE_BUILD_TYPE=Release
        EXCLUDE_FROM_ALL TRUE
    )

    ExternalProject_Get_Property(doxygen BINARY_DIR)
    add_executable(Doxygen::doxygen IMPORTED)
    set_target_properties(Doxygen::doxygen PROPERTIES IMPORTED_LOCATION "${BINARY_DIR}/bin/doxygen")

    add_dependencies(Doxygen::doxygen doxygen)
endif()


include(FetchContent)

FetchContent_Declare(
    doxygen-awesome-css
    PREFIX doxygen-awesome-css
    URL https://github.com/jothepro/doxygen-awesome-css/archive/refs/tags/v2.2.0.zip
    URL_HASH SHA256=2cff61a38694895259f5fdd04599c08d86cf9fd2dafc9950bf47af09af52e227
    DOWNLOAD_DIR "${STDGPU_EXTERNAL_DIR}/doxygen-awesome-css"
)

FetchContent_GetProperties(doxygen-awesome-css)
if(NOT doxygen-awesome-css_POPULATED)
  FetchContent_Populate(doxygen-awesome-css)
endif()

set(STDGPU_DOXYGEN_AWESOME_CSS_DIR ${doxygen-awesome-css_SOURCE_DIR})


# Check include path
set(STDGPU_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../src")
get_filename_component(STDGPU_INCLUDE_DIR ${STDGPU_INCLUDE_DIR} ABSOLUTE)


if(STDGPU_COMPILE_WARNING_AS_ERROR)
    set(STDGPU_DOXYGEN_WARN_AS_ERROR YES)
else()
    set(STDGPU_DOXYGEN_WARN_AS_ERROR NO)
endif()

set(STDGPU_DOXYFILE_IN "${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in")
set(STDGPU_DOXYFILE "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile")
set(STDGPU_DOC_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}")

configure_file(${STDGPU_DOXYFILE_IN}
               ${STDGPU_DOXYFILE}
               @ONLY)

add_custom_target(stdgpu_doc
                 COMMAND Doxygen::doxygen ${STDGPU_DOXYFILE}
                 WORKING_DIRECTORY ${STDGPU_DOC_BUILD_DIR}
                 COMMENT "Generating stdgpu API documentation with Doxygen"
                 VERBATIM)


#install(DIRECTORY "${STDGPU_DOC_BUILD_DIR}/doxygen-html/"
#        DESTINATION ${STDGPU_DOC_INSTALL_DIR}
#        COMPONENT stdgpu)

=== examples/CMakeLists.txt ===

# Input parameters:
# - File name of the example without file extension
# - File extension of the example
macro(stdgpu_detail_add_example)
    set(STDGPU_EXAMPLES_NAME "${ARGV0}")
    add_executable(${STDGPU_EXAMPLES_NAME} "${STDGPU_EXAMPLES_NAME}.${ARGV1}")
    target_compile_options(${STDGPU_EXAMPLES_NAME} PRIVATE ${STDGPU_DEVICE_FLAGS}
                                                           ${STDGPU_HOST_FLAGS})
    target_link_libraries(${STDGPU_EXAMPLES_NAME} PRIVATE stdgpu::stdgpu)
    set_target_properties(${STDGPU_EXAMPLES_NAME} PROPERTIES CXX_CLANG_TIDY "${STDGPU_PROPERTY_CLANG_TIDY}")
    set_target_properties(${STDGPU_EXAMPLES_NAME} PROPERTIES CXX_CPPCHECK "${STDGPU_PROPERTY_CPPCHECK}")
    if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.24)
        set_target_properties(${STDGPU_EXAMPLES_NAME} PROPERTIES COMPILE_WARNING_AS_ERROR "${STDGPU_COMPILE_WARNING_AS_ERROR}")
    endif()
endmacro()

macro(stdgpu_add_example_cpp)
    stdgpu_detail_add_example(${ARGV0} "cpp")
endmacro()


stdgpu_add_example_cpp(contract)
stdgpu_add_example_cpp(createAndDestroyDeviceArray)
stdgpu_add_example_cpp(createAndDestroyDeviceObject)

add_subdirectory(${STDGPU_BACKEND_DIRECTORY})

=== src/CMakeLists.txt ===
add_subdirectory(stdgpu)

=== benchmark/stdgpu/CMakeLists.txt ===

add_executable(benchmarkstdgpu main.cpp)

add_subdirectory(${STDGPU_BACKEND_DIRECTORY})

target_include_directories(benchmarkstdgpu PRIVATE
                                          "${CMAKE_CURRENT_SOURCE_DIR}/..")

target_compile_options(benchmarkstdgpu PRIVATE ${STDGPU_DEVICE_FLAGS}
                                               ${STDGPU_HOST_FLAGS}
                                               ${STDGPU_TEST_DEVICE_FLAGS}
                                               ${STDGPU_TEST_HOST_FLAGS})

target_link_libraries(benchmarkstdgpu PRIVATE
                                      stdgpu::stdgpu
                                      benchmark::benchmark)

set_target_properties(benchmarkstdgpu PROPERTIES CXX_CLANG_TIDY "${STDGPU_PROPERTY_CLANG_TIDY}")
set_target_properties(benchmarkstdgpu PROPERTIES CXX_CPPCHECK "${STDGPU_PROPERTY_CPPCHECK}")
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.24)
    set_target_properties(benchmarkstdgpu PROPERTIES COMPILE_WARNING_AS_ERROR "${STDGPU_COMPILE_WARNING_AS_ERROR}")
endif()

=== examples/cuda/CMakeLists.txt ===

macro(stdgpu_add_example_cu)
    stdgpu_detail_add_example(${ARGV0} "cu")
endmacro()

stdgpu_add_example_cu(atomic)
stdgpu_add_example_cu(bitset)
stdgpu_add_example_cu(deque)
stdgpu_add_example_cu(iterator)
stdgpu_add_example_cu(mutex_array)
stdgpu_add_example_cu(ranges)
stdgpu_add_example_cu(unordered_map)
stdgpu_add_example_cu(unordered_set)
stdgpu_add_example_cu(vector)

=== examples/hip/CMakeLists.txt ===

macro(stdgpu_add_example_hip)
    stdgpu_detail_add_example(${ARGV0} "hip")
endmacro()

stdgpu_add_example_hip(atomic)
stdgpu_add_example_hip(iterator)
stdgpu_add_example_hip(ranges)

=== examples/openmp/CMakeLists.txt ===

stdgpu_add_example_cpp(atomic)
stdgpu_add_example_cpp(bitset)
stdgpu_add_example_cpp(deque)
stdgpu_add_example_cpp(iterator)
stdgpu_add_example_cpp(mutex_array)
stdgpu_add_example_cpp(ranges)
stdgpu_add_example_cpp(unordered_map)
stdgpu_add_example_cpp(unordered_set)
stdgpu_add_example_cpp(vector)

=== src/stdgpu/CMakeLists.txt ===

set(STDGPU_INCLUDE_LOCAL_DIR "${CMAKE_CURRENT_LIST_DIR}/..")
set(STDGPU_BUILD_INCLUDE_DIR "${CMAKE_CURRENT_BINARY_DIR}/include")
set(STDGPU_BUILD_CMAKE_DIR "${CMAKE_CURRENT_BINARY_DIR}/cmake")

# Setup dependencies
find_package(thrust 1.9.9 REQUIRED MODULE)

set(STDGPU_DEPENDENCIES_INIT "
find_dependency(thrust 1.9.9 REQUIRED MODULE)
")


# Setup library options and config file
if(CMAKE_BUILD_TYPE MATCHES "Release" OR CMAKE_BUILD_TYPE MATCHES "MinSizeRel")
    set(STDGPU_ENABLE_CONTRACT_CHECKS_DEFAULT OFF)
else()
    set(STDGPU_ENABLE_CONTRACT_CHECKS_DEFAULT ON)
endif()

option(STDGPU_ENABLE_CONTRACT_CHECKS "Enable contract checks, default: OFF if CMAKE_BUILD_TYPE is Release or MinSizeRel, ON otherwise" ${STDGPU_ENABLE_CONTRACT_CHECKS_DEFAULT})
option(STDGPU_USE_32_BIT_INDEX "Use 32-bit instead of 64-bit signed integer for index_t, default: ON" ON)

configure_file("${STDGPU_INCLUDE_LOCAL_DIR}/stdgpu/config.h.in"
               "${STDGPU_BUILD_INCLUDE_DIR}/stdgpu/config.h"
               @ONLY)


if(STDGPU_BUILD_SHARED_LIBS)
    add_library(stdgpu SHARED)
else()
    add_library(stdgpu STATIC)
endif()

target_sources(stdgpu PRIVATE impl/device.cpp
                              impl/iterator.cpp
                              impl/memory.cpp)

if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.23)
    target_sources(stdgpu PUBLIC FILE_SET stdgpu_headers
                                 TYPE HEADERS
                                 BASE_DIRS ${STDGPU_INCLUDE_LOCAL_DIR}
                                 FILES algorithm.h
                                       atomic.cuh
                                       bit.h
                                       bitset.cuh
                                       compiler.h
                                       contract.h
                                       cstddef.h
                                       deque.cuh
                                       device.h
                                       execution.h
                                       functional.h
                                       iterator.h
                                       limits.h
                                       memory.h
                                       mutex.cuh
                                       numeric.h
                                       platform.h
                                       queue.cuh
                                       ranges.h
                                       stack.cuh
                                       unordered_map.cuh
                                       unordered_set.cuh
                                       utility.h
                                       vector.cuh)

    target_sources(stdgpu PUBLIC FILE_SET stdgpu_header_implementations
                                 TYPE HEADERS
                                 BASE_DIRS ${STDGPU_INCLUDE_LOCAL_DIR}
                                 FILES impl/algorithm_detail.h
                                       impl/atomic_detail.cuh
                                       impl/bit_detail.h
                                       impl/bitset_detail.cuh
                                       impl/deque_detail.cuh
                                       impl/functional_detail.h
                                       impl/iterator_detail.h
                                       impl/limits_detail.h
                                       impl/memory_detail.h
                                       impl/mutex_detail.cuh
                                       impl/numeric_detail.h
                                       impl/platform_check.h
                                       impl/preprocessor.h
                                       impl/queue_detail.cuh
                                       impl/ranges_detail.h
                                       impl/stack_detail.cuh
                                       impl/type_traits.h
                                       impl/unordered_base.cuh
                                       impl/unordered_base_detail.cuh
                                       impl/unordered_map_detail.cuh
                                       impl/unordered_set_detail.cuh
                                       impl/utility_detail.h
                                       impl/vector_detail.cuh)

    target_sources(stdgpu PUBLIC FILE_SET stdgpu_config_header
                                 TYPE HEADERS
                                 BASE_DIRS ${STDGPU_BUILD_INCLUDE_DIR}
                                 FILES "${STDGPU_BUILD_INCLUDE_DIR}/stdgpu/config.h")
else()
    target_include_directories(stdgpu PUBLIC
                                      $<BUILD_INTERFACE:${STDGPU_INCLUDE_LOCAL_DIR}>
                                      $<BUILD_INTERFACE:${STDGPU_BUILD_INCLUDE_DIR}>)
endif()

# Still required as the interface header file sets are *conditionally* enabled for clients based on *their* CMake version
target_include_directories(stdgpu PUBLIC $<INSTALL_INTERFACE:${STDGPU_INCLUDE_INSTALL_DIR}>)

if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.24)
    set_target_properties(stdgpu PROPERTIES INTERFACE_HEADER_SETS_TO_VERIFY stdgpu_headers)

    # Manually specify the correct compile language for all headers that must be compiled by the device compiler
    set(STDGPU_DEVICE_HEADERS atomic.cuh
                              bitset.cuh
                              deque.cuh
                              mutex.cuh
                              queue.cuh
                              stack.cuh
                              unordered_map.cuh
                              unordered_set.cuh
                              vector.cuh)

    if(STDGPU_BACKEND STREQUAL STDGPU_BACKEND_CUDA)
        set_source_files_properties(${STDGPU_DEVICE_HEADERS} PROPERTIES LANGUAGE CUDA)
    elseif(STDGPU_BACKEND STREQUAL STDGPU_BACKEND_HIP)
        set_source_files_properties(${STDGPU_DEVICE_HEADERS} PROPERTIES LANGUAGE HIP)
    endif()
endif()

target_compile_features(stdgpu PUBLIC cxx_std_17)

target_compile_options(stdgpu PRIVATE ${STDGPU_DEVICE_FLAGS}
                                      ${STDGPU_HOST_FLAGS})

target_link_libraries(stdgpu PUBLIC thrust::thrust)

set_target_properties(stdgpu PROPERTIES CXX_CLANG_TIDY "${STDGPU_PROPERTY_CLANG_TIDY}")
set_target_properties(stdgpu PROPERTIES CXX_CPPCHECK "${STDGPU_PROPERTY_CPPCHECK}")
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.24)
    set_target_properties(stdgpu PROPERTIES COMPILE_WARNING_AS_ERROR "${STDGPU_COMPILE_WARNING_AS_ERROR}")
endif()

add_library(stdgpu::stdgpu ALIAS stdgpu)


add_subdirectory(${STDGPU_BACKEND_DIRECTORY})


# Export targets and install header files
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.23)
    install(TARGETS stdgpu
            EXPORT stdgpu-targets
            ARCHIVE DESTINATION "${STDGPU_LIB_INSTALL_DIR}"
            LIBRARY DESTINATION "${STDGPU_LIB_INSTALL_DIR}"
            FILE_SET stdgpu_headers DESTINATION "${STDGPU_INCLUDE_INSTALL_DIR}"
            FILE_SET stdgpu_header_implementations DESTINATION "${STDGPU_INCLUDE_INSTALL_DIR}"
            FILE_SET stdgpu_config_header DESTINATION "${STDGPU_INCLUDE_INSTALL_DIR}"
            FILE_SET stdgpu_backend_headers DESTINATION "${STDGPU_INCLUDE_INSTALL_DIR}"
            FILE_SET stdgpu_backend_header_implementations DESTINATION "${STDGPU_INCLUDE_INSTALL_DIR}"
            COMPONENT stdgpu)
else()
    install(TARGETS stdgpu
            EXPORT stdgpu-targets
            DESTINATION "${STDGPU_LIB_INSTALL_DIR}"
            COMPONENT stdgpu)

    install(DIRECTORY "${STDGPU_INCLUDE_LOCAL_DIR}/" "${STDGPU_BUILD_INCLUDE_DIR}/"
            DESTINATION "${STDGPU_INCLUDE_INSTALL_DIR}"
            COMPONENT stdgpu
            FILES_MATCHING
            PATTERN "*.h"
            PATTERN "*.cuh")
endif()

# Install dependencies file and custom thrust module
configure_file("${stdgpu_SOURCE_DIR}/cmake/stdgpu-dependencies.cmake.in"
               "${STDGPU_BUILD_CMAKE_DIR}/stdgpu-dependencies.cmake"
               @ONLY)

install(FILES "${STDGPU_BUILD_CMAKE_DIR}/stdgpu-dependencies.cmake"
        DESTINATION "${STDGPU_CMAKE_INSTALL_DIR}"
        COMPONENT stdgpu)

install(FILES "${stdgpu_SOURCE_DIR}/cmake/Findthrust.cmake"
        DESTINATION "${STDGPU_CMAKE_INSTALL_DIR}"
        COMPONENT stdgpu)

install(FILES "${stdgpu_SOURCE_DIR}/cmake/${STDGPU_BACKEND_DIRECTORY}/determine_thrust_paths.cmake"
        DESTINATION "${STDGPU_CMAKE_INSTALL_DIR}/${STDGPU_BACKEND_DIRECTORY}"
        COMPONENT stdgpu)

=== test/install_test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(install_test LANGUAGES CXX)


find_package(stdgpu REQUIRED)


add_executable(install_test)

target_sources(install_test PRIVATE install_test.cpp)

target_link_libraries(install_test PRIVATE stdgpu::stdgpu)

=== test/stdgpu/CMakeLists.txt ===

add_executable(teststdgpu main.cpp)

target_sources(teststdgpu PRIVATE algorithm.cpp
                                  bit.cpp
                                  contract.cpp
                                  functional.cpp
                                  iterator.cpp
                                  limits.cpp
                                  memory.cpp
                                  numeric.cpp
                                  ranges.cpp)

target_sources(teststdgpu PRIVATE ../test_memory_utils.cpp)

add_subdirectory(${STDGPU_BACKEND_DIRECTORY})

target_include_directories(teststdgpu PRIVATE
                                      "${CMAKE_CURRENT_SOURCE_DIR}/..") # test_utils

target_compile_options(teststdgpu PRIVATE ${STDGPU_DEVICE_FLAGS}
                                          ${STDGPU_HOST_FLAGS}
                                          ${STDGPU_TEST_DEVICE_FLAGS}
                                          ${STDGPU_TEST_HOST_FLAGS})

target_link_libraries(teststdgpu PRIVATE
                                 stdgpu::stdgpu
                                 gtest)

set_target_properties(teststdgpu PROPERTIES CXX_CLANG_TIDY "${STDGPU_PROPERTY_CLANG_TIDY}")
set_target_properties(teststdgpu PROPERTIES CXX_CPPCHECK "${STDGPU_PROPERTY_CPPCHECK}")
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.24)
    set_target_properties(teststdgpu PROPERTIES COMPILE_WARNING_AS_ERROR "${STDGPU_COMPILE_WARNING_AS_ERROR}")
endif()


add_test(NAME teststdgpu
         COMMAND teststdgpu)

=== benchmark/stdgpu/cuda/CMakeLists.txt ===

target_sources(benchmarkstdgpu PRIVATE bitset.cu
                                       deque.cu
                                       mutex.cu
                                       unordered_map.cu
                                       unordered_set.cu
                                       vector.cu)

## stdgpu 1.3.0%2Bgit20220507.32e0517

=== debian/control ===
Source: stdgpu
Section: libs
Priority: optional
Maintainer: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.26.4-3~),
 hipcc [amd64 ppc64el],
 libamdhip64-dev [amd64 ppc64el],
 libgtest-dev <!nocheck>,
 librocthrust-dev [amd64 ppc64el] | libthrust-dev,
Homepage: https://github.com/stotko/stdgpu
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/stdgpu.git
Vcs-Browser: https://salsa.debian.org/debian/stdgpu
Description: Efficient STL-like Data Structures on the GPU
 stdgpu is an open-source library providing several generic GPU data structures
 for fast and reliable data management. Multiple platforms such as CUDA,
 OpenMP, and HIP are supported allowing you to rapidly write highly complex
 agnostic and native algorithms that look like sequential CPU code but are
 executed in parallel on the GPU.

Package: libstdgpu-openmp0t64
Provides: ${t64:Provides}
X-Time64-Compat: libstdgpu-openmp0d
Replaces: libstdgpu-openmp0d
Breaks: libstdgpu-openmp0d (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (OpenMP CPU backend)
 ${source:Extended-Description}
 .
 This package installs the shared library that runs on the CPU with OpenMP.

Package: libstdgpu-openmp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Conflicts: libstdgpu-dev
Provides: libstdgpu-dev
Depends:
 ${misc:Depends},
 libstdgpu-openmp0t64 (= ${binary:Version}),
 libthrust-dev,
Description: ${source:Synopsis} (OpenMP development headers)
 ${source:Extended-Description}
 .
 This package installs the development headers for the OpenMP version.

Package: libstdgpu-hip0d
Architecture: amd64 ppc64el
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (HIP backend)
 ${source:Extended-Description}
 .
 This package installs the shared library that runs with HIP.

Package: libstdgpu-hip-dev
Section: libdevel
Architecture: amd64 ppc64el
Multi-Arch: same
Conflicts: libstdgpu-dev
Provides: libstdgpu-dev
Depends:
 ${misc:Depends},
 libstdgpu-hip0d (= ${binary:Version}),
 librocthrust-dev,
Description: ${source:Synopsis} (HIP development headers)
 ${source:Extended-Description}
 .
 This package installs the development headers for the HIP version.

## stdgpu 1.3.0+git20220507.32e0517

=== debian/changelog ===
stdgpu (1.3.0+git20220507.32e0517-6ubuntu1) noble; urgency=medium

  * Merge from Debian experimental. Remaining changes:
    - Drop arm64 from libstdgpu-hip-dev and libstdgpu-hip0d architectures

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 17 Apr 2024 19:25:58 +0200

stdgpu (1.3.0+git20220507.32e0517-6) unstable; urgency=medium

  * Skip testing on armhf and armel (Closes: #1064019)

 -- Timo Röhling <roehling@debian.org>  Wed, 17 Apr 2024 16:10:56 +0200

stdgpu (1.3.0+git20220507.32e0517-5.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable (Closes: #1062926)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Apr 2024 18:26:27 +0200

stdgpu (1.3.0+git20220507.32e0517-5.1~exp3ubuntu1) noble; urgency=medium

  * Merge from Debian experimental. Remaining changes:
    - Drop arm64 from libstdgpu-hip-dev and libstdgpu-hip0d architectures
      (LP: #2061253)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Apr 2024 15:06:05 +0200

stdgpu (1.3.0+git20220507.32e0517-5.1~exp3) experimental; urgency=medium

  * Fix debian/rules to not change the upstream soname.

 -- Steve Langasek <vorlon@debian.org>  Sun, 25 Feb 2024 20:41:43 +0000

stdgpu (1.3.0+git20220507.32e0517-5.1~exp2) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.
  * Fix wrong debian/control handling in previous upload.  Closes: #1063069.

 -- Steve Langasek <vorlon@debian.org>  Sun, 18 Feb 2024 00:39:25 +0000

stdgpu (1.3.0+git20220507.32e0517-5ubuntu1) noble; urgency=medium

  * Drop arm64 from libstdgpu-hip-dev and libstdgpu-hip0d architectures
    (LP: #2061253)

 -- Cordell Bloor <cgmb@slerp.xyz>  Sat, 13 Apr 2024 15:32:28 -0600

stdgpu (1.3.0+git20220507.32e0517-5) unstable; urgency=medium

  * Fix wrong alignment test to actually provoke wrong alignment

 -- Timo Röhling <roehling@debian.org>  Sat, 01 Jul 2023 23:13:20 +0200

stdgpu (1.3.0+git20220507.32e0517-4) unstable; urgency=medium

  * Fix Build-Depend on librocthrust-dev and libthrust-dev

 -- Timo Röhling <roehling@debian.org>  Sat, 01 Jul 2023 11:29:46 +0200

stdgpu (1.3.0+git20220507.32e0517-3) unstable; urgency=medium

  * Handle architecture-dependent signedness of char and wchar_t
  * Limit HIP build to supported architectures

 -- Timo Röhling <roehling@debian.org>  Sat, 01 Jul 2023 10:59:15 +0200

stdgpu (1.3.0+git20220507.32e0517-2) unstable; urgency=medium

  * Source-only upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Thu, 15 Jun 2023 23:30:28 +0200

stdgpu (1.3.0+git20220507.32e0517-1) experimental; urgency=medium

  * Initial release. (Closes: #1037131)

 -- Timo Röhling <roehling@debian.org>  Mon, 05 Jun 2023 21:38:21 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

BUILD_TESTS := $(if $(or $(filter nocheck,$(DEB_BUILD_OPTIONS)),$(filter armhf armel,$(DEB_HOST_ARCH))),OFF,ON)
BUILD_HIP := $(if $(filter amd64 ppc64el,$(DEB_HOST_ARCH)),ON,OFF)
SOVERSION := 0d
SOVERSION_ISH := 0t64
SOVERSION_HIP := 0d

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake  --builddirectory=obj-openmp -- \
		-DSTDGPU_SETUP_COMPILER_FLAGS=ON \
		-DSTDGPU_BUILD_TESTS=$(BUILD_TESTS) \
		-DSTDGPU_BUILD_EXAMPLES=OFF \
		-DSTDGPU_BUILD_BENCHMARKS=OFF \
		-DSTDGPU_BUILD_SHARED_LIBS=ON \
		-DSTDGPU_BACKEND=STDGPU_BACKEND_OPENMP \
		-DSTDGPU_SOVERSION=$(SOVERSION) \
		-DSTDGPU_OUTPUT_NAME=stdgpu_openmp
ifeq ($(BUILD_HIP),ON)
	dh_auto_configure --buildsystem=cmake  --builddirectory=obj-hip -- \
		-DSTDGPU_SETUP_COMPILER_FLAGS=ON \
		-DSTDGPU_BUILD_TESTS=OFF \
		-DSTDGPU_BUILD_EXAMPLES=OFF \
		-DSTDGPU_BUILD_BENCHMARKS=OFF \
		-DSTDGPU_BUILD_SHARED_LIBS=ON \
		-DSTDGPU_BACKEND=STDGPU_BACKEND_HIP \
		-DCMAKE_HIP_ARCHITECTURES=OFF \
		-DSTDGPU_SOVERSION=$(SOVERSION_HIP) \
		-DSTDGPU_OUTPUT_NAME=stdgpu_hip
endif

override_dh_auto_build:
	dh_auto_build --buildsystem=cmake --builddirectory=obj-openmp
ifeq ($(BUILD_HIP),ON)
	dh_auto_build --buildsystem=cmake --builddirectory=obj-hip
endif

override_dh_auto_test:
	dh_auto_test --buildsystem=cmake --builddirectory=obj-openmp
ifeq ($(BUILD_HIP),ON)
	dh_auto_test --buildsystem=cmake --builddirectory=obj-hip
endif

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake --builddirectory=obj-openmp --destdir=debian/tmp-openmp
ifeq ($(BUILD_HIP),ON)
	dh_auto_install --buildsystem=cmake --builddirectory=obj-hip --destdir=debian/tmp-hip
endif

override_dh_install:
	dh_install --package=libstdgpu-openmp$(SOVERSION_ISH) --package=libstdgpu-openmp-dev --sourcedir=debian/tmp-openmp
ifeq ($(BUILD_HIP),ON)
	dh_install --package=libstdgpu-hip$(SOVERSION_HIP) --package=libstdgpu-hip-dev --sourcedir=debian/tmp-hip
endif

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,dversionmangle=auto,oversionmangle=s%$%+ds%,repack \
 https://api.github.com/repos/stotko/stdgpu/tags \
 tarball/(?:[^"]*?/)?v?@ANY_VERSION@
